<dx-data-grid class="gridContainer box-shadow" #gridMonthly [columnAutoWidth]='true' [allowColumnResizing]='true'
    [allowColumnReordering]='true' [rowAlternationEnabled]='ui.rowAlternationEnabled'
    [showColumnLines]='ui.showColumnLines' [showRowLines]='ui.showRowLines' [dataSource]='dsMonthly'
    [height]='ui.fullHeight' [columnHidingEnabled]='ui.columnHidingEnabled'
    (onToolbarPreparing)='toolbarPreparing($event)'>
    <dxo-export [enabled]='true' [enabled]='true' fileName='generare'></dxo-export>
    <dxo-header-filter [visible]='true'></dxo-header-filter>
    <dxo-group-panel [visible]='true'></dxo-group-panel>
    <dxo-search-panel [visible]='true'></dxo-search-panel>
    <dxo-state-storing [enabled]="true" type="localStorage" storageKey="qhseMonthly"></dxo-state-storing>
    <dxo-filter-row [visible]='true'></dxo-filter-row>
    <dxo-column-chooser [enabled]="true" mode='dragAndDrop'></dxo-column-chooser>
    <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
    <dxo-remote-operations [sorting]="true" [paging]="true" [filtering]="true"></dxo-remote-operations>
    <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='true'></dxo-scrolling>

    <dxi-column type="buttons" [width]="100" fixedPosition='left' [fixed]='true' [allowResizing]='false'
        [showInColumnChooser]='false'>
        <dxi-button hint='Editează' icon="edit" [onClick]="onEditMonthlyClick"></dxi-button>
        <!-- <dxi-button hint='Actualizează' icon="assets/img/recheck.svg" [onClick]="onRecheckMonthlyClick"></dxi-button> -->
    </dxi-column>

    <dxi-column [caption]='ds.lg.format("ENTITY")' dataField='company' dataType='string'></dxi-column>
    <dxi-column [caption]='ds.lg.format("WORKSTATION")' dataField='workCenter' dataType='string'></dxi-column>
    <dxi-column [caption]='ds.lg.format("WASTE CODE")' dataField='wasteCode' dataType='string'></dxi-column>
    <dxi-column [caption]='ds.lg.format("MONTH")' dataField='month' dataType='number' minWidth='150'>
        <dxo-lookup [dataSource]='dsMonths' displayExpr='name' valueExpr='id'></dxo-lookup>
    </dxi-column>
    <dxi-column [caption]='ds.lg.format("YEAR")' dataField='year' dataType='number'></dxi-column>
    <dxi-column [caption]='ds.lg.format("U")' dataField='wasteUom' dataType='string' minWidth='110' [allowEditing]='false'>
        <dxo-lookup [dataSource]='ds.uom' valueExpr='id' displayExpr='value'></dxo-lookup>
    </dxi-column>
    <dxi-column [caption]='ds.lg.format("ADJUSTED GENERATE")' dataField='adjustment' dataType='number'></dxi-column>
    <dxi-column [caption]='ds.lg.format("VALORIFIED")' dataField='valued' dataType='number'></dxi-column>
    <dxi-column [caption]='ds.lg.format("OVER")' dataField='taken' dataType='number'></dxi-column>
    <dxi-column [caption]='ds.lg.format("IN PROGRESS")' dataField='inProgress' dataType='number'></dxi-column>
    <dxi-column [caption]='ds.lg.format("TRANSFER")' dataField='transfer' dataType='number'></dxi-column>
    <dxi-column [caption]='ds.lg.format("REMOVED")' dataField='eliminated' dataType='number'></dxi-column>
    <dxi-column [caption]='ds.lg.format("GENERATED")' dataField='generated' dataType='number'></dxi-column>
    <dxi-column caption='Stoc anterior' dataField='previousStock' dataType='number' [allowHeaderFiltering]='false'>
    </dxi-column>
    <dxi-column [caption]='ds.lg.format("STOCK")' dataField='stock' dataType='number' [allowHeaderFiltering]='false'></dxi-column>
    <dxi-column [caption]='ds.lg.format("MADE BY")' dataField='createdBy' dataType='string'></dxi-column>
    <dxi-column [caption]='ds.lg.format("MODIFIED BY")' dataField='modifiedBy' dataType='string'></dxi-column>
    <dxi-column [caption]='ds.lg.format("CREATION DATE")' dataField='created' dataType='datetime' calculateSortValue='created'
        [calculateDisplayValue]='ds.getDateTime'>
    </dxi-column>
    <dxi-column [caption]='ds.lg.format("LAST MODIFIED")' dataField='modified' dataType='datetime' calculateSortValue='modified'
        [calculateDisplayValue]='ds.getDateTime'>
    </dxi-column>

</dx-data-grid>

<dx-popup [title]='ds.lg.format("MONTHLY REPORT")' [(visible)]='isMonthlyVisible' [minWidth]='ui.minWidthPopup' maxWidth='90vw'
    width='auto' maxHeight='90vh' height='auto'>
    <div *dxTemplate="let data of 'content'">
        <dx-scroll-view [height]='ui.scrollHeight' width="auto" direction="both">
            <app-edit-monthly [monthlyData]='monthly'></app-edit-monthly>
        </dx-scroll-view>
    </div>
    <dxi-toolbar-item toolbar="bottom" location="after" widget="dxButton"
        [options]="{ text: ds.lg.format('SAVE'), icon:'save', type: 'normal', onClick: onSaveGenerateAdj, validationGroup:'monthlyValidation' }">
    </dxi-toolbar-item>
</dx-popup>

<dx-popup [title]='ds.lg.format("UPDATE")' [(visible)]='isRecheckMonthlyVisible' [minWidth]='ui.minWidthPopup' maxWidth='90vw'
    width='auto' maxHeight='90vh' height='auto'>
    <div *dxTemplate="let data of 'content'">
        <dx-form [colCount]="1" [formData]='recheckData' [showValidationSummary]="false"
            validationGroup="recheckValidation" labelLocation="left">
            <dxi-item [label]="{text: ds.lg.format('YEAR')}" dataField="year" editorType="dxNumberBox"
                [editorOptions]="{  min: year.min, max: year.current }">
                <dxi-validation-rule type="required"></dxi-validation-rule>
            </dxi-item>
            <dxi-item [label]="{text: ds.lg.format('MONTH')}" dataField="month" editorType="dxSelectBox"
                [editorOptions]="{ dataSource: dsMonths, valueExpr: 'id', displayExpr: 'name' }"></dxi-item>
        </dx-form>
    </div>
    <dxi-toolbar-item toolbar="bottom" location="after" widget="dxButton"
        [options]="{ text: ds.lg.format('SAVE'), icon:'save', type: 'normal', onClick: onSaveRecheck, validationGroup:'recheckValidation' }">
    </dxi-toolbar-item>
</dx-popup>